/*-
 * SPDX-License-Identifier: BSD-2-Clause-FreeBSD
 */

#pragma once

#include "daemon.h"

struct daemon_named_list;
typedef struct daemon_named_list daemon_named_list_t;
struct daemon_named_list
{
	/* next named list in the chain. */
	daemon_named_list_t* next;
	/* linked list of daemons tied to this name. */
	daemon_node_t* head;
	/* name of this list. actual size varies by name length. */
	char name[1];
};

daemon_named_list_t* daemon_named_list_create(const char* name);
/* add one daemon to the list. */
void daemon_node_list_add(daemon_node_t** node, daemon_t* insert);
void daemon_named_list_add(daemon_named_list_t *list, daemon_t *insert);
void daemon_named_list_destroy(daemon_node_t** root);

struct hash
{
	/* hash table size. */
	unsigned size;
	/* hash table. */
	daemon_named_list_t** buckets;
};
typedef struct hash hash_t;

void hash_init(hash_t* hash, unsigned size);
daemon_node_t* hash_find(const hash_t* hash, const char* key);
void hash_add(hash_t* hash, const char* key, daemon_t* daemon);
