/*-
* SPDX-License-Identifier: BSD-2-Clause-FreeBSD
*/

#include "graph.h"

/* 
    This program leaks memory. This is intentional. Once the required output 
    is produced, the program exits so there's no real point to free anything. 
*/

int main(int argc, const char *argv[])
{
    graph_t graph;

    graph_init(&graph);
    if (graph_parse(&graph, argc, argv) > 0)
        /* parse failure */
        return 2;
    if (!graph_resolve(&graph))
        /* dependency / cyclic graph failure. */
        return 1;

    while (graph_group_print(&graph)) ;
    /* any remaining daemons imply a cycle. in theory, 'resolve' will have caught it. */
    return graph.count > 0 ? 1 : 0;
}
